unit MainFrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,Wininet,
  DB, DBTables, Grids, DBGrids, Gauges, LMDWndProcComponent, LMDTrayIcon,
  Menus, LMDCustomComponent, LMDContainerComponent, LMDBaseDialog,
  LMDAboutDlg, ComCtrls, ToolWin, Buttons, ImgList, TB97Tlbr, TB97Ctls,
  TB97, ExtCtrls,IniFiles;

type
  TTemplate = Class
  public
    FileName: String;
    Name, Icon, Description, Catagory: String;
    Text, Text_Cpp: String;
    EnableC, EnableCpp: Boolean;
    CursorX, CursorY, CursorX_Cpp, CursorY_Cpp: Integer;
    Console, Cpp, DLL : Boolean;
    CompilerOptions, Libs, ProjectName, IncludeDirs: String;
  end;

  TMain = class(TForm)
    LMDAboutDlg1: TLMDAboutDlg;
    PopupMenu1: TPopupMenu;
    mnuInfo: TMenuItem;
    N1: TMenuItem;
    mnuQuit: TMenuItem;
    NormIcon: TLMDTrayIcon;
    StatusBar1: TStatusBar;
    MainMenu1: TMainMenu;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    ImageList1: TImageList;
    PopupMenu2: TPopupMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    ToolBar3: TToolBar;
    Image4: TImage;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ToolButton12: TToolButton;
    ToolButton13: TToolButton;
    GroupBox1: TGroupBox;
    Gauge1: TGauge;
    N10: TMenuItem;
    LargeIcons1: TMenuItem;
    List1: TMenuItem;
    SmallIcons1: TMenuItem;
    Details1: TMenuItem;
    ListView1: TListView;
    Timer1: TTimer;
    N11: TMenuItem;
    Timer2: TTimer;
    Timer3: TTimer;
    ImageList: TImageList;
    N12: TMenuItem;
    N13: TMenuItem;
    N14: TMenuItem;
    N15: TMenuItem;
    a1: TMenuItem;
    a2: TMenuItem;
    a3: TMenuItem;
    a4: TMenuItem;
    a5: TMenuItem;
    a6: TMenuItem;
    a7: TMenuItem;
    a8: TMenuItem;
    N16: TMenuItem;
    N17: TMenuItem;
    procedure mnuQuitClick(Sender: TObject);
    procedure mnuInfoClick(Sender: TObject);
    procedure NormIconDblClick(Sender: TObject);
    procedure N9Click(Sender: TObject);
    procedure CustomTKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure LargeIcons1Click(Sender: TObject);
    procedure List1Click(Sender: TObject);
    procedure Details1Click(Sender: TObject);
    procedure SmallIcons1Click(Sender: TObject);
    procedure ListView1ColumnClick(Sender: TObject; Column: TListColumn);
    procedure ToolButton8Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ToolButton9Click(Sender: TObject);
    procedure ToolButton10Click(Sender: TObject);
    procedure ToolButton12Click(Sender: TObject);
    procedure N8Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
    procedure N13Click(Sender: TObject);
    procedure N14Click(Sender: TObject);
    procedure a1Click(Sender: TObject);
    procedure a2Click(Sender: TObject);
    procedure a3Click(Sender: TObject);
    procedure a5Click(Sender: TObject);
    procedure a6Click(Sender: TObject);
    procedure a7Click(Sender: TObject);
    procedure a8Click(Sender: TObject);
    procedure a4Click(Sender: TObject);

  private
    { Private declarations }
  public
  IndexFile:Integer;
  aFiles:Array[1..500000]of string;
  Sour,Destin,NameF,MinS:String;
  mData:Array[1..100,1..5]of Variant;
  Maxdata:Integer;
  StopCycle:boolean;
  InTimer:Boolean;
  Err:Short;

  //--------
  Lang,
  MError1,
  MErrorCopy,
  MErrorto,
  Mrun      ,
  Mprofile  ,
  Mprofileexist,
  MNochoice    ,MconfigDel   ,
  Mstop        ,MconfirmDel  ,
  Bcreate,
  bdelete,Bconfig,BRun,
  Mfile,MView,MInfo,
  BnewProfile,Bcopynow,
  Bexit,Vlarge,
  Vsmall,Vlist,
  Vdetails,VlogFile,
  VdelLogfile:String;

LFolderSelect,Wizard1,
Wizard2,Wizard3,
Wizard4,Wizard5,
Wizard6,Wizard7,
Wizard8,Wbpring,
Wmnext, wbcancel,
wgroup, wLabel1,
wlabel2,wlabel3,
wlabel4,wlabel5,
wlabel6,wlabel7,
wlabel5A,wlabel5b,Mlang:String;

IndexLang:Integer;
LangFiles:Array[1..100]of string;
  procedure LangSelect(SLang:String);
  procedure SearchLangFile(const PathName, FileName : string);
  procedure FileSearch(const PathName, FileName : string; const InDir : boolean);
  procedure BackupFiles(Inp,OutP:String);

    { Public declarations }
  end;

var
  Main: TMain;


  Type
    TCallBack = procedure (Position, Size: LongInt); { export; }

    procedure FileCopy(Const InFileName, OutFileName: String);
    procedure SecondFileCopy(Const InFileName, OutFileName: String);
    Procedure ThirthFileCopy( Const InFileName, OutFileName: String );

implementation

uses wizardfrm;


{$R *.dfm}
procedure ThirthFileCopy(Const InFileName, OutFileName: String);
BEGIN
Main.Statusbar1.panels[3].Text:='3 method';
If not  Windows.CopyFile(pChar(InFileName),
                             pChar(OutFileName),
                             FALSE //Fail if Exists
                             )
                             then raise exception.Create('');
END;

procedure FileCopy(Const InFileName, OutFileName: String);
  Const BufSize = 3*4*4096;
  Type
    PBuffer = ^TBuffer;
    TBuffer = Array[1..BufSize] of Byte;
  var Size: Integer;
      Buffer: PBuffer;
      infile,outfile: File;
      SizeDone,SizeFile: LongInt;
  begin
  Main.Statusbar1.panels[3].Text:='1 method';

    if (InFileName <> OutFileName) then
    begin
      buffer := Nil;
      Assign(infile,InFileName);
      System.Reset(infile,1);
      try
        SizeFile := FileSize(infile);
        Assign(outfile,OutFileName);
        System.Rewrite(outfile,1);
        try
          SizeDone := 0;
          New(Buffer);
          repeat
          Application.ProcessMessages;
            BlockRead(infile,Buffer^,BufSize,Size);
            Inc(SizeDone,Size);
            BlockWrite(outfile,Buffer^,Size);
            if Main.StopCycle then begin
              System.close(outfile);
              deletefile(OutFileName);
              System.close(infile);
              break;
            end;
//            if getkeystate(vk_escape) and 128=128 then begin showmessage('d'); break; end;
          until Size < BufSize;
          FileSetDate( TFileRec(outfile).Handle,
            FileGetDate( TFileRec(infile).Handle ));
        finally
          If Buffer <> Nil Then
            Dispose(Buffer);
          System.close(outfile)
        end;
      finally
        System.close(infile);
      end;
    end
    else
      Raise EInOutError.Create(Main.MError1)
  end ;{FastFileCopy}


  Procedure SecondFileCopy( Const InFileName, OutFileName: String );
  Var
    S,T: TFileStream;
  Begin
  Main.Statusbar1.panels[3].Text:='2 method';

    S := TFileStream.Create( InFileName, fmOpenRead );
    try
      T := TFileStream.Create( OutFileName, fmOpenWrite or fmCreate );
      try
        T.CopyFrom(S, S.Size ) ;
        FileSetDate(T.Handle, FileGetDate( S.Handle ));
      finally
        T.Free;
      end;
    finally
      S.Free;
    end;
  End;

Function BCopy(Infile,OutFile:String):Boolean;
Var
   fin,fout: file of Byte;
   SIZEIN,SIZEOUT:LongInt;
begin

If not FileExists(OutFile) then begin Result:=True; exit;end;
If (FileAge(Infile)=FileAge(OutFile)) then Result:=False else begin Result:=True; exit; end;

{SIZEIN:=0;
SIZEOUT:=0;
TRY
  AssignFile(fin, Infile);
  Reset(fin);
  sizeIn := FileSize(fin);
  AssignFile(fout, Outfile);
  Reset(fout);
  sizeOut := FileSize(fout);
  closeFile(fout);CloseFile(fin);
  If sizeout<>sizein then Result:=True else Result:=False;
Except
Result:=true;
END;}
end;

procedure Tmain.FileSearch(const PathName, FileName : string; const InDir : boolean);
var Rec  : TSearchRec;
    SelectedFile : string;
    Path : string;
begin
Path := IncludeTrailingBackslash(PathName);

if FindFirst(Path + FileName, faAnyFile - faDirectory, Rec) = 0 then
 try
   repeat
   if Main.StopCycle then break;
      Inc(IndexFile);
      aFiles[IndexFile]:=Path+Rec.Name;
      StatusBar1.Panels[1].text:=aFiles[IndexFile];
      {Rec.Name; Rec.Size; FileDateToDateTime(Rec.Time);}
     Application.ProcessMessages;
   until FindNext(Rec) <> 0;
 finally
   FindClose(Rec);
 end;

 If not InDir then Exit;

if FindFirst(Path + '*.*', faDirectory, Rec) = 0 then
 try
   repeat
   if Main.StopCycle then break;
   if (Rec.Name<>'.') and (Rec.Name<>'..') then
     FileSearch(Path + Rec.Name, FileName, True);
   until FindNext(Rec) <> 0;
 finally
   FindClose(Rec);
 end;
 StatusBar1.Panels[1].text:='';
 Statusbar1.panels[3].Text:='';
end; //procedure FileSearch

procedure TMain.BackupFiles(Inp,OutP:String);
var
I:Integer;
sFile,toFile:String;
List: TStringList;

begin
IndexFile:=0;
FileSearch(Inp,'*.*',True);
GroupBox1.Visible:=True;
Gauge1.Progress:=0;
Gauge1.MaxValue:=IndexFile;
Err:=0;
Try
For I:=1 to IndexFile do begin
Gauge1.Progress:=i;

 sFile:=aFiles[I];
 toFile:=Outp+copy(aFiles[i],3,Length(aFiles[i]));
 ForceDirectories(extractfilepath(toFile));

 if   not DirectoryExists(extractfilepath(Outp)) then begin
   Err:=1;
   raise exception.Create('');
 end;  

 StatusBar1.Panels[1].text:=sFile;
 if Main.StopCycle then break;
 Try
 if Bcopy(sFile,toFile) then
    FileCopy(sfile,toFile);
 except
    Try
    SecondFileCopy(sfile,toFile);
    Except
       Try
       ThirthFileCopy(sfile,toFile);
       Except
       Err:=1;
       if not fileexists(ExtractFilePath (Application.ExeName) + 'error.log') then begin
        List := TStringList.Create;
        List.SaveToFile(ExtractFilePath (Application.ExeName) + 'Error.log');
        List.Free;
       end;
       List := TStringList.Create;
       List.LoadFromFile (
        ExtractFilePath (Application.ExeName) + 'error.log');
        List.Add(datetimetostr(now)+' '+MErrorCopy+' '+sFile+' '+MErrorto+' '+toFile);
        List.SaveToFile(ExtractFilePath (Application.ExeName) + 'Error.log');
        List.Free;
       end;//       Except
    end;//       Except
 end;//      Except
 Application.ProcessMessages;
end;
    Except
    on E: Exception do begin
      Err:=1;
       if not fileexists(ExtractFilePath (Application.ExeName) + 'error.log') then begin
        List := TStringList.Create;
        List.SaveToFile(ExtractFilePath (Application.ExeName) + 'Error.log');
        List.Free;
       end;
       List := TStringList.Create;
       List.LoadFromFile (
        ExtractFilePath (Application.ExeName) + 'error.log');
        List.Add(datetimetostr(now)+' '+E.Message);
        List.SaveToFile(ExtractFilePath (Application.ExeName) + 'Error.log');
        List.Free;
    end;

    End;
 StatusBar1.Panels[1].text:='';
 Statusbar1.panels[3].Text:='';
GroupBox1.Visible:=False;

ToolButton12.Caption:=Mrun;
ToolButton12.imageindex:=3;

end;

procedure TMain.mnuQuitClick(Sender: TObject);
begin
show;
Close;
end;

procedure TMain.mnuInfoClick(Sender: TObject);
begin
  LMDAboutDlg1.Execute;
end;

procedure TMain.NormIconDblClick(Sender: TObject);
begin
show;
end;

procedure TMain.N9Click(Sender: TObject);
begin
  LMDAboutDlg1.Execute;
end;


procedure TMain.CustomTKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  Template: TTemplate;
begin
  if Key = VK_DELETE then
     if Application.MessageBox('Do you really want to remove this template from disk?',
       'Confirm', MB_YESNO + MB_ICONQUESTION) = 6 then
     begin
     //   Template := TTemplate(TListView(PageControl.ActivePage.Controls[0]).Selected.Data);
        SysUtils.DeleteFile(Template.FileName);
        if FileExists(Template.Text) then
           SysUtils.DeleteFile(Template.Text);
        if FileExists(Template.Text_Cpp) then
           SysUtils.DeleteFile(Template.Text_Cpp);
        Template.Free;
 //       TListView(PageControl.ActivePage.Controls[0]).Selected.Free;
     end;
end;


procedure TMain.LargeIcons1Click(Sender: TObject);
begin
  ListView1.ViewStyle := vsIcon;
  LargeIcons1.Checked := True;
  List1.Checked := FALSE;
  Details1.Checked :=FALSE;
  SmallIcons1.Checked :=FALSE;

end;

procedure TMain.List1Click(Sender: TObject);
begin
  ListView1.ViewStyle := vsList;
  List1.Checked := True;
  LargeIcons1.Checked :=FALSE;
  Details1.Checked :=FALSE;
  SmallIcons1.Checked :=FALSE;
end;

procedure TMain.Details1Click(Sender: TObject);
begin
  ListView1.ViewStyle := vsReport;
  Details1.Checked := True;
  List1.Checked := FALSE;
  LargeIcons1.Checked :=FALSE;
  SmallIcons1.Checked :=FALSE;

end;

procedure TMain.SmallIcons1Click(Sender: TObject);
begin
  ListView1.ViewStyle := vsSmallIcon;
  SmallIcons1.Checked := True;
  List1.Checked := FALSE;
  LargeIcons1.Checked :=FALSE;
  Details1.Checked :=FALSE;

end;

procedure TMain.ListView1ColumnClick(Sender: TObject; Column: TListColumn);
begin
  ListView1.AlphaSort;
end;
Function GetField(S:String;Fieldaa:Short):String;
var
i,k,Lcount:integer;
begin
K:=Length(S);
Lcount:=1;
Result:='';
For i:=1 to K do begin
 If Copy(S,I,1)=';' then inc(Lcount);
 If (Lcount=Fieldaa)and(Copy(S,I,1)<>';') then Result:=Result+Copy(S,I,1);
end;

end;

procedure LoadList;
var
  ImageList1, ImageList2: TImageList;
  List: TStringList;
  NewItem: TListItem;
  I: Integer;
begin
With main do begin
  // stops warning message
  NewItem := nil;
  Maxdata:=0;
  ListView1.Items.Clear;
 if not fileexists(ExtractFilePath (Application.ExeName) + 'Items.txt') then begin
        List := TStringList.Create;
        List.SaveToFile(ExtractFilePath (Application.ExeName) + 'Items.txt');
        List.Free;
 end;

  List := TStringList.Create;
  try
    List.LoadFromFile (
      ExtractFilePath (Application.ExeName) + 'Items.txt');
    for I := 0 to List.Count - 1 do
      begin
        // a new item
        NewItem := ListView1.Items.Add;
        NewItem.Caption := GetField(List [I],1);
        NewItem.ImageIndex:=0;
        inc(Maxdata);
        mData[MaxData,1]:=GetField(List [I],1);
        mData[MaxData,2]:=GetField(List [I],2);
        mData[MaxData,3]:=GetField(List [I],3);
        mData[MaxData,4]:=GetField(List [I],4);
        MData[MaxData,5]:=mData[MaxData,4];
      end;
  finally
    List.Free;
  end;
StatusBar1.panels[0].text:=inttostr(Maxdata)+' '+Mprofile;

end;
end;

procedure TMain.ToolButton8Click(Sender: TObject);
var
  List: TStringList;
  I:Integer;
begin
  Wizard := TWizard.Create(self);
  Wizard.ShowModal;
  Wizard.Free;
  if  NameF<>'' then begin
     For I:=1 to MaxData do begin
       if uppercase(Namef)=Uppercase(mData[I,1]) then begin
         showmessage(Mprofileexist);
         exit;
       end;
     end;
   List := TStringList.Create;
    List.LoadFromFile (
      ExtractFilePath (Application.ExeName) + 'Items.txt');
    List.Add(NameF+';'+Sour+';'+Destin+';'+Mins);
    List.SaveToFile(ExtractFilePath (Application.ExeName) + 'Items.txt');
    List.Free;
    LoadList;
  end;


end;



Procedure DeleteF(S:String);
var
  List: TStringList;
  I,KeepD: Integer;
begin
//With main do begin
  // stops warning message
  KeepD:=-5;
  List := TStringList.Create;
  try
    List.LoadFromFile (
      ExtractFilePath (Application.ExeName) + 'Items.txt');
    for I := 0 to List.Count - 1 do
      begin
        // a new item
        if Uppercase(S)=Uppercase(GetField(List [I],1)) then KeepD:=I;
      end;
  finally
    If KeepD<>-5 then List.Delete(KeepD);
    List.SaveToFile(ExtractFilePath (Application.ExeName) + 'Items.txt');
    List.Free;
  end;

end;

procedure TMain.ToolButton9Click(Sender: TObject);
begin
  if ListView1.Selected = nil then
  begin
    Showmessage(MNochoice);
    exit;
  end;

  if MessageDlg(MconfigDel+' '+listview1.Selected.Caption+' ?',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
  DeleteF(listview1.Selected.Caption);
  LoadList;
  end;
end;


procedure TMain.ToolButton10Click(Sender: TObject);
var
  List: TStringList;
  I:Integer;
begin
  if ListView1.Selected = nil then
  begin
    Showmessage(MNochoice);
    exit;
  end;
     I:=0;
     Repeat
      Inc(I);
     Until uppercase(listview1.Selected.Caption)=Uppercase(mData[I,1]);

  Wizard := TWizard.Create(self);
  With  Wizard Do begin
   Esource.Text:=mData[I,2];
   Edestination.Text:=mData[I,3];
   Ename.Text:=mData[I,1];
   ShowModal;
   Free;
  end;

  if  NameF<>'' then begin
   List := TStringList.Create;
    List.LoadFromFile (
      ExtractFilePath (Application.ExeName) + 'Items.txt');
    List.Delete(I-1);
    List.Add(NameF+';'+Sour+';'+Destin+';'+Mins);
    List.SaveToFile(ExtractFilePath (Application.ExeName) + 'Items.txt');
    List.Free;
    LoadList;
  end;

end;

procedure TMain.ToolButton12Click(Sender: TObject);
begin
//if GroupBox1.Visible then begin showmessage('Wait !'); exit;end;
If ToolButton12.imageindex=4 then begin
  StopCycle:=True;
  exit;
end else StopCycle:=False;

  if ListView1.Selected = nil then
  begin
    Showmessage(MNochoice);
    exit;
  end;

ToolButton12.Caption:=MStop;
ToolButton12.imageindex:=4;

StatusBar1.Panels[2].Text:=mData[Listview1.Selected.Index+1,1];
BackupFiles(mData[Listview1.Selected.Index+1,2],mData[Listview1.Selected.Index+1,3]);
Listview1.Selected.ImageIndex:=Err;

StatusBar1.Panels[2].Text:='';
Statusbar1.panels[3].Text:='';

end;

procedure TMain.N8Click(Sender: TObject);
begin
Close;
end;

procedure TMain.Timer1Timer(Sender: TObject);
var
I:integer;
begin
If inTimer then Exit;
InTimer:=True;

For I:=1 to MaxData do begin
 if MData[I,5]=0 then begin
  ToolButton12.Caption:=Mstop;
  ToolButton12.imageindex:=4;
  StatusBar1.Panels[2].Text:=mData[I,1];
  BackupFiles(mData[I,2],mData[I,3]);
  Listview1.Items[i-1].ImageIndex:=Err;
  StatusBar1.Panels[2].Text:='';
  Statusbar1.panels[3].Text:='';
    MData[I,5]:=MData[I,4];
 end else MData[I,5]:=MData[I,5]-1;
end;
 InTimer:=False;
end;

procedure TMain.Timer3Timer(Sender: TObject);
var
I:integer;
begin
timer3.Enabled:=false;
For i:=1 to maxdata do
     MData[I,5]:=0;

end;

procedure TMain.N13Click(Sender: TObject);
begin
WinExec( PChar( 'NOTEPAD ' + ExtractFilePath( Application.ExeName) + 'Error.log'), SW_SHOW);
end;

procedure TMain.N14Click(Sender: TObject);
begin
If MessageDlg( MconfirmDel, mtInformation, [mbYes, mbNo], 0) = mrYes then
  deletefile(ExtractFilePath (Application.ExeName) + 'error.log');

end;
procedure TMain.FormCreate(Sender: TObject);
var
I:integer;
ini: Tinifile;
begin

IndexLang:=0;
SearchLangFile(ExtractFilePath(application.exename),'*.lang');
For I:=1 to IndexLang do begin
 case I of
  1:begin
    A1.Visible:=True;
    A1.Caption:=copy(LangFiles[i],1,length(LangFiles[i])-5);
    end;
  2:begin
    A2.Visible:=True;
    A2.Caption:=copy(LangFiles[i],1,length(LangFiles[i])-5);
    end;
  3:begin
    A3.Visible:=True;
    A3.Caption:=copy(LangFiles[i],1,length(LangFiles[i])-5);
    end;
  4:begin
    A4.Visible:=True;
    A4.Caption:=copy(LangFiles[i],1,length(LangFiles[i])-5);
    end;
  5:begin
    A5.Visible:=True;
    A5.Caption:=copy(LangFiles[i],1,length(LangFiles[i])-5);
    end;
  6:begin
    A6.Visible:=True;
    A6.Caption:=copy(LangFiles[i],1,length(LangFiles[i])-5);
    end;
  7:begin
    A7.Visible:=True;
    A7.Caption:=copy(LangFiles[i],1,length(LangFiles[i])-5);
    end;
  8:begin
    A8.Visible:=True;
    A8.Caption:=copy(LangFiles[i],1,length(LangFiles[i])-5);
    end;
  end;
end;

ini:=TiniFile.Create(ExtractFilePath(application.exename)+'CopyBackup.ini');
Lang:=ini.ReadString('Language','Language','English');
ini.WriteString('Language','Language',Lang);
ini.free;

LangSelect(lang);
LoadList;

end;


procedure Tmain.SearchLangFile(const PathName, FileName : string);
var Rec  : TSearchRec;
    SelectedFile : string;
    Path : string;
begin
Path := IncludeTrailingBackslash(PathName);

if FindFirst(Path + FileName, faAnyFile - faDirectory, Rec) = 0 then
 try
   repeat
      Inc(IndexLang);
      LangFiles[IndexLang]:=Rec.Name;
     Application.ProcessMessages;
   until FindNext(Rec) <> 0;
 finally
   FindClose(Rec);
 end;

end; //procedure FileSearch


Function noand(S:string):String;
var
I,k:Integer;
begin
K:=Length(S);
Result:='';
For I:=1 to K do If copy(S,I,1)<>'&' then Result:=Result+copy(S,I,1);
end;
procedure TMain.LangSelect(SLang:String);
var
I:integer;
ini: Tinifile;
begin
Slang:=NoAnd(Slang);

ini:=TiniFile.Create(ExtractFilePath(application.exename)+'CopyBackup.ini');
//Lang:=ini.ReadString('Language','Language',Slang);
ini.WriteString('Language','Language',SLang);

ini.free;

ini:=TiniFile.Create(ExtractFilePath(application.exename)+Slang+'.Lang');
MError1      :=ini.ReadString('Language','Error1','File cannot be copied onto itself');
MErrorCopy   :=ini.ReadString('Language','MErrorCopy','  ');
MErrorto     :=ini.ReadString('Language','MErrorsto','');
Mrun         :=ini.ReadString('Language','Mrun','');
Mprofile     :=ini.ReadString('Language','Mprofile',' ()');
Mprofileexist:=ini.ReadString('Language','Mprofileexist','   ');
MNochoice    :=ini.ReadString('Language','MNochoice','   ');
MconfigDel   :=ini.ReadString('Language','MconfigDel','      ');
Mstop        :=ini.ReadString('Language','Mstop','');
MconfirmDel  :=ini.ReadString('Language','MconfirmDel','        ;');

ini.WriteString('Language','Error1',MError1);
ini.WriteString('Language','MErrorCopy',MErrorCopy);
ini.WriteString('Language','MErrorsto',MErrorto);
ini.WriteString('Language','Mrun',Mrun);
ini.WriteString('Language','Mprofile',Mprofile);
ini.WriteString('Language','Mprofileexist',Mprofileexist);
ini.WriteString('Language','MNochoice',MNochoice);
ini.WriteString('Language','MconfigDel',MconfigDel);
ini.WriteString('Language','Mstop',Mstop);
ini.WriteString('Language','MconfirmDel',MconfirmDel);

Bcreate   :=ini.ReadString('Language','Bcreate','');
bdelete   :=ini.ReadString('Language','bdelete','');
Bconfig   :=ini.ReadString('Language','Bconfig','');
BRun      :=ini.ReadString('Language','BRun','');
Mfile     :=ini.ReadString('Language','Mfile','');
MView     :=ini.ReadString('Language','MView','');
MInfo     :=ini.ReadString('Language','MInfo',' ...');
BnewProfile:=ini.ReadString('Language','BnewProfile',' ');
Bcopynow   :=ini.ReadString('Language','Bcopynow',' ');
Bexit      :=ini.ReadString('Language','Bexit','');
Vlarge     :=ini.ReadString('Language','Vlarge',' ');
Vsmall     :=ini.ReadString('Language','Vsmall',' ');
Vlist      :=ini.ReadString('Language','Vlist','');
Vdetails   :=ini.ReadString('Language','Vdetails','');
VlogFile   :=ini.ReadString('Language','VlogFile','  ');
VdelLogfile:=ini.ReadString('Language','VdelLogfile','. ');

ini.WriteString('Language','Bcreate',Bcreate);
ini.WriteString('Language','bdelete',bdelete);
ini.WriteString('Language','Bconfig',Bconfig);
ini.WriteString('Language','BRun',BRun);
ini.WriteString('Language','Mfile',Mfile);
ini.WriteString('Language','MView',MView);
ini.WriteString('Language','MInfo',MInfo);
ini.WriteString('Language','BnewProfile',BnewProfile);
ini.WriteString('Language','Bcopynow',Bcopynow);
ini.WriteString('Language','Bexit',Bexit);
ini.WriteString('Language','Vlarge',Vlarge);
ini.WriteString('Language','Vsmall',Vsmall);
ini.WriteString('Language','Vlist',Vlist);
ini.WriteString('Language','Vdetails',Vdetails);
ini.WriteString('Language','VlogFile',VlogFile);
ini.WriteString('Language','VdelLogfile',VdelLogfile);

LFolderSelect:=ini.ReadString('Language','LFolderSelect','  ');

Wizard1:=ini.ReadString('Language','Wizard1','    ?');
Wizard2:=ini.ReadString('Language','Wizard2','   ?');
Wizard3:=ini.ReadString('Language','Wizard3','');
Wizard4:=ini.ReadString('Language','Wizard4',' >');
Wizard5:=ini.ReadString('Language','Wizard5',' ');
Wizard6:=ini.ReadString('Language','Wizard6','');
Wizard7:=ini.ReadString('Language','Wizard7','     ');
Wizard8:=ini.ReadString('Language','Wizard8','     ');
Wbpring:=ini.ReadString('Language','Wbpring','< ');
Wmnext:=ini.ReadString('Language','Wmnext',' >');
wbcancel:=ini.ReadString('Language','wbcancel','');
wgroup:=ini.ReadString('Language','wgroup','');
wLabel1:=ini.ReadString('Language','wlabel1','                 ');
wlabel2:=ini.ReadString('Language','wlabel2','    ?');
wlabel3:=ini.ReadString('Language','wlabel3',' :');
wlabel4:=ini.ReadString('Language','wlabel4',' :');
wlabel5:=ini.ReadString('Language','wlabel5','     ');
wlabel5A:=ini.ReadString('Language','wlabel5A','&&  ');
wlabel5B:=ini.ReadString('Language','wlabel5B','    ');
wlabel6:=ini.ReadString('Language','wlabel6','');
wlabel7:=ini.ReadString('Language','wlabel7','');

ini.wRITEString('Language','wlabel5A',wlabel5A);
ini.WriteString('Language','wlabel5B',wlabel5B);
ini.WriteString('Language','Wizard1',Wizard1);
ini.WriteString('Language','Wizard2',Wizard2);
ini.WriteString('Language','Wizard3',Wizard3);
ini.WriteString('Language','Wizard4',Wizard4);
ini.WriteString('Language','Wizard5',Wizard5);
ini.WriteString('Language','Wizard6',Wizard6);
ini.WriteString('Language','Wizard7',Wizard7);
ini.WriteString('Language','Wizard8',Wizard8);
ini.WriteString('Language','Wbpring',Wbpring);
ini.WriteString('Language','Wmnext',Wmnext);
ini.WriteString('Language','wbcancel',wbcancel);
ini.WriteString('Language','wgroup',wgroup);
ini.WriteString('Language','wLabel1',wLabel1);
ini.WriteString('Language','wLabel2',wlabel2);
ini.WriteString('Language','wLabel3',wlabel3);
ini.WriteString('Language','wLabel4',wlabel4);
ini.WriteString('Language','wLabel5',wlabel5);
ini.WriteString('Language','wLabel6',wlabel6);
ini.WriteString('Language','wLabel7',wlabel7);

Mlang:=ini.ReadString('Language','Mlang',' ');
ini.WriteString('Language','Mlang',Mlang);

ini.free;

ToolButton8.Caption:=Bcreate;
ToolButton9.Caption:=bdelete;
ToolButton10.Caption:=Bconfig;
ToolButton12.Caption:=BRun;
N2.Caption:=Mfile;
N10.Caption:=MView;
N9.Caption:=MInfo;
mnuInfo.Caption:=MInfo;

N3.Caption:=BnewProfile;
N5.Caption:=Bcopynow;
N6.Caption:=bdelete;
N11.Caption:=Bconfig;
N8.Caption:=Bexit;
mnuQuit.Caption:=Bexit;
LargeIcons1.Caption:=Vlarge;
SmallIcons1.Caption:=Vsmall;
List1.Caption:=Vlist;
Details1.Caption:=Vdetails;
N13.Caption:=VlogFile;
N16.Caption:=VlogFile;
N14.Caption:=VdelLogfile;
N15.Caption:=Mlang;

end;

procedure TMain.a1Click(Sender: TObject);
begin
LangSelect(a1.Caption);
end;

procedure TMain.a2Click(Sender: TObject);
begin
LangSelect(a2.Caption);

end;

procedure TMain.a3Click(Sender: TObject);
begin
LangSelect(a3.Caption);

end;

procedure TMain.a5Click(Sender: TObject);
begin
LangSelect(a5.Caption);

end;

procedure TMain.a6Click(Sender: TObject);
begin
LangSelect(a6.Caption);

end;

procedure TMain.a7Click(Sender: TObject);
begin
LangSelect(a7.Caption);

end;

procedure TMain.a8Click(Sender: TObject);
begin
LangSelect(a8.Caption);

end;

procedure TMain.a4Click(Sender: TObject);
begin
LangSelect(a4.Caption);
end;

end.












