unit wizardfrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, dxCore, dxButtons, StdCtrls, Buttons;

type
  TWizard = class(TForm)
    Image2: TImage;
    Bmeta: TdxButton;
    Bprin: TdxButton;
    dxButton3: TdxButton;
    Bevel1: TBevel;
    Label2: TLabel;
    Esource: TEdit;
    Edestination: TEdit;
    Label1: TLabel;
    Label3: TLabel;
    BrowseBtn: TBitBtn;
    BrowseBtn2: TBitBtn;
    Label4: TLabel;
    GroupBox1: TGroupBox;
    Edit1: TEdit;
    Label5: TLabel;
    Ename: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure BrowseBtnClick(Sender: TObject);
    procedure dxButton3Click(Sender: TObject);
    procedure BmetaClick(Sender: TObject);
    procedure BprinClick(Sender: TObject);
    procedure BrowseBtn2Click(Sender: TObject);
  private
    { Private declarations }
  public
  wcount:Integer;
  DirPath:String;
  Procedure InterfaceShow(Inf:Integer);
    { Public declarations }
  end;

var
  Wizard: TWizard;

implementation

uses folderSelectfrm, MainFrm;

{$R *.dfm}
Procedure TWizard.InterfaceShow(Inf:Integer);
begin

Case Inf of
0:begin
Bprin.Enabled:=False;
Bmeta.Enabled:=True;
BrowseBtn.Visible:=false;
BrowseBtn2.visible:=false;
Label1.visible:=false;
Label2.visible:=True;
Label4.Visible:=False;
Esource.Visible:=false;
Edestination.Visible:=False;
Label3.Visible:=False;
Edestination.Visible:=False;
GroupBox1.Visible:=false;
end;
1:begin
Label2.visible:=False;
Bprin.Enabled:=True;
Bmeta.Enabled:=True;
BrowseBtn.Visible:=True;
BrowseBtn2.visible:=false;
Label1.visible:=True;
Label4.Visible:=False;
Esource.Visible:=True;
Edestination.Visible:=False;
Label3.Visible:=True;
Label3.Caption:=Main.Wizard1;
Edestination.Visible:=False;
Esource.Enabled:=True;
GroupBox1.Visible:=false;
GroupBox1.Visible:=false;
Esource.SetFocus;

end;
2:begin
Label3.Visible:=True;
Label3.Caption:=Main.Wizard2;
BrowseBtn.Visible:=False;
Esource.Visible:=True;
Esource.Enabled:=False;
Label4.Visible:=true;
BrowseBtn2.visible:=True;
Label2.visible:=False;
Bprin.Enabled:=True;
Bmeta.Enabled:=True;
Label1.visible:=True;
Edestination.Visible:=True;
GroupBox1.Visible:=false;
GroupBox1.Visible:=false;
Edestination.SetFocus;

end;
3:begin
GroupBox1.Visible:=True;
GroupBox1.Caption:=Main.Wizard3;
Ename.Visible:=False;
Label5.Visible:=True;
Edit1.Visible:=True;
Bmeta.Caption:=Main.Wizard4;
Edit1.SetFocus;
end;

4:begin
GroupBox1.Visible:=True;
GroupBox1.Caption:=Main.Wizard5;
Ename.Visible:=True;
Label5.Visible:=false;
Edit1.Visible:=False;
Bmeta.Caption:=Main.Wizard6;
Ename.SetFocus;
end;

end;//case

End;


procedure TWizard.FormCreate(Sender: TObject);
begin
InterfaceShow(0);
wcount:=0;
bprin.Caption:=Main.Wbpring;
Bmeta.Caption:=Main.Wmnext;
dxButton3.Caption:=Main.wbcancel;

GroupBox1.Caption:=Main.wgroup;
Label5.caption:=Main.wLabel1;
Label3.caption:=Main.wlabel2;
label1.Caption:=Main.wlabel3;
label4.Caption:=Main.wlabel4;
label2.Caption:=Main.wlabel5;
Label6.CAPTION:=Main.wlabel5A;
Label7.CAPTION:=Main.wlabel5B;
BrowseBtn.Caption:=Main.wlabel6;
BrowseBtn2.Caption:=Main.wlabel7;

end;


procedure TWizard.BrowseBtnClick(Sender: TObject);
begin
  folderSelect := TfolderSelect.Create(self);
  if folderSelect.ShowModal = mrOK then begin
     Esource.Text:=DirPath;
  end;//if mrOK
  folderSelect.Free;




end;

procedure TWizard.dxButton3Click(Sender: TObject);
begin
MAin.NameF:='';
close;
end;

procedure TWizard.BmetaClick(Sender: TObject);
begin

If wcount=4 then begin
 Main.Sour:=Esource.Text;
 Main.Destin:=Edestination.Text;
 MAin.NameF:=Ename.Text;
 Try
  Main.MinS:=Inttostr(StrToint(Edit1.text));
  except
  Main.MinS:='10';
  end;//try

 close;
end else begin
wcount:=wcount+1;
if (Esource.text='')and (wcount=2) then begin
  Showmessage(Main.Wizard7);
  wcount:=1;
  exit;
end;
if (Edestination.text='')and (wcount=3) then begin
  Showmessage(Main.Wizard8);
  wcount:=2;
  exit;
end;


InterfaceShow(wcount);
end;

end;

procedure TWizard.BprinClick(Sender: TObject);
begin
wcount:=wcount-1;
InterfaceShow(wcount);
end;

procedure TWizard.BrowseBtn2Click(Sender: TObject);
begin
  folderSelect := TfolderSelect.Create(self);
  if folderSelect.ShowModal = mrOK then begin
   Edestination.Text:=DirPath;
  end;//if mrOK
  folderSelect.Free;

end;

end.
